com.tibbo.aggregate.common.context

## Class AbstractCallerController

- java.lang.Object
- - com.tibbo.aggregate.common.context.AbstractCallerController

- All Implemented Interfaces:
    CallerController
  Direct Known Subclasses:
    UncheckedCallerController

      public abstract class AbstractCallerController
      extends java.lang.Object
      implements CallerController

- - ### Nested Class Summary

    - ### Nested classes/interfaces inherited from interface com.tibbo.aggregate.common.context.CallerController

      `CallerController.Type`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `AbstractCallerController(CallerData callerData)`

  - ### Method Summary

    All Methods Static Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `void` | `addLockedContext(Context context)`
    `void` | `addLogoutListener(LogoutListener logoutListener)`
    `void` | `cache(java.lang.String path, Context context)`
    `DataTable` | `createLockedContextsTable()`
    `java.lang.String` | `getAddress()`
    `CallerData` | `getCallerData()`
    `static java.util.List<CallerController>` | `getControllers()`
    `java.util.Date` | `getCreationTime()`
    `java.lang.String` | `getEffectiveUsername()`
    `java.lang.String` | `getInheritedUsername()`
    `java.lang.String` | `getLogin()`
    `PermissionCache` | `getPermissionCache()`
    `Permissions` | `getPermissions()`
    `java.util.Map<java.lang.String,java.lang.Object>` | `getProperties()`
    `java.lang.String` | `getSessionId()`
    `java.lang.Long` | `getSessionIdCounter()`
    `java.lang.Long` | `getTokenExpirationPeriod()`
    `CallerController.Type` | `getType()`
    `java.lang.String` | `getUsername()`
    `boolean` | `isConnectionTerminatable()`
    `boolean` | `isLoggedIn()`
    `boolean` | `isPermissionCheckingEnabled()`
    `boolean` | `isWeb()`
    `void` | `login(java.lang.String username, java.lang.String inheritedUsername, Permissions permissons)`
    `void` | `logout()`
    `protected void` | `logoutInternal(boolean softly)`
    `void` | `logoutSoftly()` Used for logout of the user without closing of the corresponded connections in ClientCallerControllers instances.
    `Context` | `lookup(java.lang.String path)`
    `void` | `removeLockedContext(Context context)`
    `void` | `removeLogoutListener(LogoutListener logoutListener)`
    `void` | `sendFeedback(int level, java.lang.String message)`
    `void` | `sendFeedback(int level, java.lang.String message, java.lang.Integer duration)`
    `void` | `setAddress(java.lang.String address)`
    `void` | `setInheritedUsername(java.lang.String inheritedUsername)`
    `protected void` | `setLoggedIn(boolean loggedIn)`
    `void` | `setLogin(java.lang.String login)`
    `void` | `setSessionId(java.lang.String sessionId)`
    `void` | `setTokenExpirationPeriod(java.lang.Long tokenExpirationPeriod)`
    `void` | `setType(CallerController.Type type)`
    `protected void` | `setUsername(java.lang.String username)`
    `java.lang.String` | `toString()`
    `void` | `unlockAllContexts()`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

    - ### Methods inherited from interface com.tibbo.aggregate.common.context.CallerController

      `getClientIP, getLoginType, isHeadless`

- - ### Constructor Detail

    - #### AbstractCallerController

          public AbstractCallerController(CallerData callerData)

  - ### Method Detail

    - #### isLoggedIn

          public boolean isLoggedIn()

      Specified by:
        `isLoggedIn` in interface `CallerController`

    - #### setLoggedIn

          protected void setLoggedIn(boolean loggedIn)

    - #### isPermissionCheckingEnabled

          public boolean isPermissionCheckingEnabled()

      Specified by:
        `isPermissionCheckingEnabled` in interface `CallerController`

    - #### getPermissionCache

          public PermissionCache getPermissionCache()

      Specified by:
        `getPermissionCache` in interface `CallerController`

    - #### getCallerData

          public CallerData getCallerData()

      Specified by:
        `getCallerData` in interface `CallerController`

    - #### getProperties

          public java.util.Map<java.lang.String,java.lang.Object> getProperties()

      Specified by:
        `getProperties` in interface `CallerController`

    - #### sendFeedback

          public void sendFeedback(int level,
                                   java.lang.String message)

      Specified by:
        `sendFeedback` in interface `CallerController`

    - #### sendFeedback

          public void sendFeedback(int level,
                                   java.lang.String message,
                                   java.lang.Integer duration)

      Specified by:
        `sendFeedback` in interface `CallerController`

    - #### getControllers

          public static java.util.List<CallerController> getControllers()

    - #### toString

          public java.lang.String toString()

      Overrides:
        `toString` in class `java.lang.Object`

    - #### getPermissions

          public Permissions getPermissions()

      Specified by:
        `getPermissions` in interface `CallerController`

    - #### getUsername

          public java.lang.String getUsername()

      Specified by:
        `getUsername` in interface `CallerController`

    - #### setUsername

          protected void setUsername(java.lang.String username)

    - #### getLogin

          public java.lang.String getLogin()

      Specified by:
        `getLogin` in interface `CallerController`

    - #### setLogin

          public void setLogin(java.lang.String login)

    - #### getInheritedUsername

          public java.lang.String getInheritedUsername()

      Specified by:
        `getInheritedUsername` in interface `CallerController`

    - #### setInheritedUsername

          public void setInheritedUsername(java.lang.String inheritedUsername)

    - #### getEffectiveUsername

          public java.lang.String getEffectiveUsername()

      Specified by:
        `getEffectiveUsername` in interface `CallerController`

    - #### getType

          public CallerController.Type getType()

      Specified by:
        `getType` in interface `CallerController`

    - #### setType

          public void setType(CallerController.Type type)

    - #### getAddress

          public java.lang.String getAddress()

      Specified by:
        `getAddress` in interface `CallerController`

    - #### setAddress

          public void setAddress(java.lang.String address)

    - #### getCreationTime

          public java.util.Date getCreationTime()

      Specified by:
        `getCreationTime` in interface `CallerController`

    - #### getSessionId

          public java.lang.String getSessionId()

      Specified by:
        `getSessionId` in interface `CallerController`

    - #### setSessionId

          public void setSessionId(java.lang.String sessionId)

    - #### getTokenExpirationPeriod

          public java.lang.Long getTokenExpirationPeriod()

      Specified by:
        `getTokenExpirationPeriod` in interface `CallerController`

    - #### setTokenExpirationPeriod

          public void setTokenExpirationPeriod(java.lang.Long tokenExpirationPeriod)

    - #### login

          public void login(java.lang.String username,
                            java.lang.String inheritedUsername,
                            Permissions permissons)
                     throws ContextException

      Specified by:
        `login` in interface `CallerController`
      Throws:
        `ContextException`

    - #### logoutSoftly

          public final void logoutSoftly()

      Description copied from interface: `CallerController`
      Used for logout of the user without closing of the corresponded connections in ClientCallerControllers instances.
      Specified by:
        `logoutSoftly` in interface `CallerController`

    - #### logout

          public final void logout()

      Specified by:
        `logout` in interface `CallerController`

    - #### logoutInternal

          protected void logoutInternal(boolean softly)

    - #### addLogoutListener

          public void addLogoutListener(LogoutListener logoutListener)

    - #### removeLogoutListener

          public void removeLogoutListener(LogoutListener logoutListener)

    - #### getSessionIdCounter

          public java.lang.Long getSessionIdCounter()

      Specified by:
        `getSessionIdCounter` in interface `CallerController`

    - #### lookup

          public Context lookup(java.lang.String path)

      Specified by:
        `lookup` in interface `CallerController`

    - #### cache

          public void cache(java.lang.String path,
                            Context context)

      Specified by:
        `cache` in interface `CallerController`

    - #### addLockedContext

          public void addLockedContext(Context context)

      Specified by:
        `addLockedContext` in interface `CallerController`

    - #### removeLockedContext

          public void removeLockedContext(Context context)

      Specified by:
        `removeLockedContext` in interface `CallerController`

    - #### createLockedContextsTable

          public DataTable createLockedContextsTable()

      Specified by:
        `createLockedContextsTable` in interface `CallerController`

    - #### unlockAllContexts

          public void unlockAllContexts()

      Specified by:
        `unlockAllContexts` in interface `CallerController`

    - #### isWeb

          public boolean isWeb()

      Specified by:
        `isWeb` in interface `CallerController`

    - #### isConnectionTerminatable

          public boolean isConnectionTerminatable()

      Specified by:
        `isConnectionTerminatable` in interface `CallerController`